### ivr_niv2_site.tcl (masque)
###
### si le numero de l appelant est cache, le rebond 1...0! est interdit (le 0 est systematiquement interdit) 
### si le numero appelant n'est pas connu de radius le rebond n est pas autorise
### si le numero appelant est connu de radius le rebond est autorise (1...0!)
###
### remplacer ivr_site.au par ivr_ville.au (et charger le fichier .au correspondant dans la flash)
### modifier la partie proc act_PromptCollect_dest suivant le site a configurer
### si besoin modifier dans proc init les parametres globaux (initialDigitTimeout, interDigitTimeout...)
###
###
#
# clid_col_npw_npw.tcl
#----------------------------------
# September 1998, David Ramsthaler
#
# Copyright (c) 1998-2001, 2002 by cisco Systems, Inc.
# All rights reserved.
#------------------
# Mimic clid_col_npw_npw in the SP1.0 release.
#
# It authenticates using (ani, null) for (account, password). If
# that fails, it allows 3 tries to collect account number.
#
# If authentication passes, it collects the destination number and
# places the call.
# 
# The main routine is at the bottom. Start reading the script there.
#

proc init { } {
    global param
    global param1

    set param(interruptPrompt) true
    set param(abortKey) *
    set param(terminationKey) #
### attend n secondes avant d'envoyer le digit
    set param(initialDigitTimeout) 1
### attend n secondes entre les digits
### set param(interDigitTimeout) 3

    set param1(interruptPrompt) true
    set param1(abortKey) *
    set param1(terminationKey) # 
    set param1(dialPlan) true
### attend n secondes avant d'envoyer le digit
    set param1(initialDigitTimeout) 1
### attend n secondes entre les digits
### set param(interDigitTimeout) 3  

}
proc init_perCallVars { } {
    global beep
    global ani_authen 
    global fcnt 
    global rcnt
    set beep 0
    set fcnt 0
    set rcnt 0
    set ani_authen 1
}
proc act_Setup { } {
### variable utilise pour controler les droits de sur-numerotation 
    global check_ani_null
    set check_ani_null 0
    	 
    init_perCallVars

    leg setupack leg_incoming
    leg proceeding leg_incoming
    leg connect leg_incoming
    set ani [infotag get leg_ani]


### partie rajoutee pour gerer les ANI caches
### si le champ ANI est vide, alors la valeur de check_ani_null sera de 1
	if { $ani == "" } {
        set check_ani_null 1
        }
### fin de la partie rajoutee pour gerer les ANI caches


### modification de la longueur de ANI pour authentifier les sept derniers caracteres
    set newani [string range $ani end-6 end] 
    aaa authenticate $newani ""
    
}

proc act_Authenticated { } {
    global param
    global param1
    global ani_authen 
    global fcnt 
    global account
### variable utilise pour authentification statique (ANI non connu de aaa)    
    global ani_unknown
### variable utilise pour controler les droits de sur-numerotation
    global check_aaa
    
### partie originelle qui sera matchee lorsque ANI est connu de aaa
    if { $ani_authen == 1 } {
         set acct [infotag get leg_ani]
    } else {
         set acct $account
    }
    set status [infotag get evt_status]
    set roaming [infotag get aaa_roaming $acct]
 
    if { ($status == "au_000") ||
         ($roaming == "match") } {
	
	set did  [infotag get leg_isdid]
	set dnis [infotag get leg_dnis]
	set dnislen [string len $dnis ]

	if { $did && $dnislen } {
	    leg setup $dnis callInfo leg_incoming
	    fsm setstate  PLACECALL
	    
	} else {
		    
	    leg collectdigits leg_incoming param1 
### enregistrement audio pour le site	
	    media play leg_incoming flash:ivr_site.au
### variable avec valeur 0 donnant plus de droit pour la sur-numerotation
	    set check_aaa 0
	}
	return 
    } 

### partie rajoutee qui sera matchee lorsque ANI n est pas connu de aaa
    if { ($status != "au_000") ||
         ($roaming == "match") } {
	
	set did  [infotag get leg_isdid]
	set dnis [infotag get leg_dnis]
	set dnislen [string len $dnis ]

	if { $did && $dnislen } {
	    leg setup $dnis callInfo leg_incoming
	    fsm setstate  PLACECALL
	    
	} else {
		
### authentification statique des ANI non renseignes dans aaa
### la variable ani est remplace par ANI_ANONYMOUS (username a rentrer dans le routeur et dans le serveur radius)
            set ani_unknown ANI_ANONYMOUS
	    aaa authenticate $ani_unknown ""
            set status [infotag get evt_status]                
	    leg collectdigits leg_incoming param1 
### enregistrement audio pour le site	    
	    media play leg_incoming flash:ivr_site.au
### variable avec valeur donnant moins de droit pour la sur-numerotation
	    set check_aaa 1
	}  					
	return       
        }
        
    if { $ani_authen == 1 } {	
	#check roaming stuff ???

	act_GetAcct
	
	set ani_authen 0
	fsm setstate GETACCOUNT
    } else {
	incr fcnt
	if { $fcnt < 3 } {
	    act_GetAcct
	    fsm setstate GETACCOUNT
	} else {   
	    media play leg_incoming flash:auth_failed.au
	    fsm setstate CALLDISCONNECT
 	}
    }
}


proc act_GetAcct { } {
    global param
    global fcnt

    #enter account NO:
    set pattern(account) .+
    
    leg collectdigits leg_incoming param pattern
    if {$fcnt == 0} {
	media play leg_incoming flash:enter_account.au
    } else {
	media play leg_incoming flash:auth_fail_retry.au
    }
}

proc act_PromptCollect_acct { } {
    global currentState
    global account
    global param
    global rcnt

    set status [infotag get evt_status]
    #matched pattern
    if {$status == "cd_005"} {
	set account [infotag get evt_dcdigits]
	aaa authenticate $account ""
        set rcnt 0
	return
    }

    #Unsupported feature or Unknown event
    if {$status == "cd_010"} {
        media play leg_incoming flash:auth_failed.au
        puts "\nUnsupported request."
        fsm setstate CALLDISCONNECT
        return
    }
    
    #aborted/timeout/invalid
    incr rcnt
    if {$rcnt >= 3} {
        media play leg_incoming flash:auth_failed.au
        fsm setstate CALLDISCONNECT
        return
    }

    act_GetAcct
    fsm setstate same_state
    return 
}



proc act_PromptCollect_dest { } {
    global dest
    global matching
    global param1
    global rcnt
### variable utilise pour controler les droits de sur-numerotation
    global check_aaa
### variable utilise pour controler les droits de sur-numerotation 
    global check_ani_null
        
    set status [infotag get evt_status]
    #matched dialplan
    if {$status == "cd_004"} {
    set matching [infotag get evt_dcdigits]
  
### traitement de la sur-numerotation pour le site de: site
### a modifier suivant le site
###
### 0 interdit systematiquement
### 1...0! interdit pour ANI non connu de aaa
### 1...0! autorise pour ANI reconnu par radius
### 1 pour XXXXXX
### 2 pour XXXXXX
### 3 pour XXXXXX
### 4 pour XXXXXX
### 5 pour XXXXXX
### 6 pour XXXXXX
### 7 pour XXXXXX
### 9 pour XXXXXX

### check pattern 0 1 2 3 4 5 6 7 8 9
### analyse de la pattern pour autoriser ou non 1...0!
    if { ([regexp {^0} $matching matching]) || 
         ([regexp {^1...0} $matching matching] && $check_aaa == 1) ||
         ([regexp {^1...0} $matching matching] && $check_ani_null == 1) } {
    set dest "ATTENTION UTILISATION DU 0 ILLICITE"
    leg setup $dest callInfo leg_incoming
### destination vers postes a partir du chiffre - a modifier suivant le site
#    } elseif {$matching == 1} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 2} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 3} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 4} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 5} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 6} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 7} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 8} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } elseif {$matching == 9} {
#    set dest 1201603
#    leg setup $dest callInfo leg_incoming
#    } else {
### sur-numerotation vers tous postes
    set dest [infotag get evt_dcdigits]
    leg setup $dest callInfo leg_incoming}
    return
    }       
### fin du traitement de la sur-numerotation

    #Unsupported feature or Unknown event
    if {$status == "cd_010"} {
        fsm setstate CALLDISCONNECT
    return
    }
    
    #Aborted/disconnected/timeout
    incr rcnt
    if {$rcnt >= 3} {
        media play leg_incoming flash:auth_failed.au
        fsm setstate CALLDISCONNECT
        return
    }

    leg collectdigits leg_incoming param1
### enregistrement audio pour le site	
    media play leg_incoming flash:ivr_site.au
    fsm setstate GETDEST
    return 

}	

proc act_CallSetupDone { } {
### rajout variable param1 pour pouvoir sur-numeroter de nouveau si le numero
### n est pas connu, occupe, ou non autorise
    global param1
    global beep
    set status [infotag get evt_status]

    if { $status == "ls_000"} {
	
	set  creditTimeLeft [infotag get leg_settlement_time leg_all]
	if { ($creditTimeLeft == "unlimited") || 
	     ($creditTimeLeft == "uninitialized") } {
	    puts "\n Unlimited Time"
	} else {
	    # start the timer for ...
	    if { $creditTimeLeft < 2 } {
		set beep 1
		set delay $creditTimeLeft
	    } else {
		set delay [expr $creditTimeLeft - 2]
	    }
	    timer start leg_timer $delay leg_incoming
	}
    } else {
### modification du script originel pour sur-numeroter de nouveau en cas d'erreur
### enregistrement audio pour le site (il peut etre different de ivr_site.au)
        media play leg_incoming flash:ivr_site.au
        leg collectdigits leg_incoming param1
        fsm setstate GETDEST 
    }

}

proc act_Timer { } {
    global beep 
    global incoming
    global outgoing

    set incoming [infotag get leg_incoming]
    set outgoing [infotag get leg_outgoing]
    
    if { $beep == 0 } {
	#insert a beep ...to the caller
	connection destroy con_all
	set beep 1
    } else {
        connection destroy con_all
        fsm setstate LASTWARN
    }
}

proc act_LastWarn { } {
    media play leg_incoming flash:out_of_time.au
}

proc act_Destroy { } {
    media play leg_incoming flash:beep.au 
}

proc act_Beeped { } {
    global incoming
    global outgoing

    connection create $incoming $outgoing
}

proc act_ConnectedAgain { } {
    #get the timer value again and start the timer ???
    #set delay [infotag get VARTAG]
    timer start leg_timer 2 leg_incoming
}

proc act_Ignore { } {
# Dummy
    puts "Event Capture"
}

proc act_Cleanup { } {
    call close
}


init 


#------------------
#   State Machine
#----------------------------------
  set fsm(any_state,ev_disconnected)   "act_Cleanup   same_state"
  
  set fsm(CALL_INIT,ev_setup_indication)   "act_Setup AUTHENTICATE"
 
  set fsm(AUTHENTICATE,ev_authenticate_done)   "act_Authenticated  GETDEST"

  set fsm(GETACCOUNT,ev_collectdigits_done)   "act_PromptCollect_acct AUTHENTICATE"

  set fsm(GETDEST,ev_collectdigits_done)   "act_PromptCollect_dest PLACECALL"
 
  set fsm(PLACECALL,ev_setup_done)   "act_CallSetupDone      CALLACTIVE"

  set fsm(CALLACTIVE,ev_leg_timer)   "act_Timer            INSERTBEEP"
  set fsm(INSERTBEEP,ev_destroy_done)   "act_Destroy       same_state"
  set fsm(INSERTBEEP,ev_media_done)   "act_Beeped          same_state" 
  set fsm(INSERTBEEP,ev_create_done)   "act_ConnectedAgain CALLACTIVE"
  
  set fsm(LASTWARN,ev_destroy_done)     "act_LastWarn        CALLDISCONNECT"

  set fsm(CALLACTIVE,ev_disconnected)   "act_Cleanup         CALLDISCONNECT"
  set fsm(CALLDISCONNECT,ev_media_done)   "act_Cleanup       same_state"
  set fsm(CALLDISCONNECT,ev_disconnect_done)   "act_Cleanup  same_state"
  set fsm(CALLDISCONNECT,ev_leg_timer)   "act_Cleanup        same_state"  

  fsm define fsm CALL_INIT



